"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SteppingManager = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Copyright (c) 2017-present, Facebook, Inc.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * This source code is licensed under the BSD-style license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * LICENSE file in the root directory of this source tree. An additional grant
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * of patent rights can be found in the PATENTS file in the same directory.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _babelTypes = require("babel-types");

var _invariant = require("./../invariant.js");

var _invariant2 = _interopRequireDefault(_invariant);

var _Stepper = require("./Stepper.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SteppingManager = exports.SteppingManager = function () {
  function SteppingManager(channel) {
    _classCallCheck(this, SteppingManager);

    this._channel = channel;
  }

  _createClass(SteppingManager, [{
    key: "processStepCommand",
    value: function processStepCommand(kind, currentNode) {
      if (kind === "in") {
        this._processStepIn(currentNode);
      }
      // TODO: implement stepOver and stepOut
    }
  }, {
    key: "_processStepIn",
    value: function _processStepIn(ast) {
      (0, _invariant2.default)(this._stepInto === undefined);
      (0, _invariant2.default)(ast.loc && ast.loc.source);
      this._stepInto = new _Stepper.StepIntoStepper(ast.loc.source, ast.loc.start.line, ast.loc.start.column);
    }
  }, {
    key: "isStepComplete",
    value: function isStepComplete(ast) {
      if (ast.loc && ast.loc.source) {
        if (this._stepInto && this._stepInto.isComplete(ast)) {
          this._stepInto = undefined;
          this._channel.sendStoppedResponse("Step Into", ast.loc.source, ast.loc.start.line, ast.loc.start.column);
          return true;
        }
      }
      return false;
    }
  }, {
    key: "onDebuggeeStop",
    value: function onDebuggeeStop(ast, reason) {
      if (reason !== "Step Into") {
        // stopped for another reason, e.g. breakpoint
        if (this._stepInto !== undefined) {
          // we're in the middle of a step into, but debuggee has stopped for another reason here first, so cancel this step into
          this._stepInto = undefined;
        }
      }

      //TODO: handle other stepping related stopped reasons when they are implemented
    }
  }]);

  return SteppingManager;
}();
//# sourceMappingURL=SteppingManager.js.map